#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <tlhelp32.h>

bool TrimProcess(DWORD pid)
{
	HANDLE	pro = OpenProcess(PROCESS_SET_QUOTA, 0, pid);
	if(!pro)
		return false;

	bool result = SetProcessWorkingSetSize(pro, -1, -1);
	CloseHandle(pro);

	return result;
}


void TrimAllProcesses()
{
	HANDLE			th32 = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	PROCESSENTRY32	pro32;

	if(INVALID_HANDLE_VALUE == th32)
		return;

	pro32.dwSize = sizeof(pro32);

	if( !Process32First(th32, &pro32) )
	{
		CloseHandle(th32);
		return;
	}

	do
	{
		TrimProcess(pro32.th32ProcessID);
	} while(Process32Next(th32, &pro32) );

	CloseHandle(th32);
	return;
}


void entry32()
{
	TrimAllProcesses();
}
