#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <tlhelp32.h>

#include <stdlib.h>
#include <stdio.h>

#include "wildmatch.h"


bool TrimProcess(DWORD pid)
{
	HANDLE	pro = OpenProcess(PROCESS_SET_QUOTA, 0, pid);
	if(!pro)
		return false;

	bool result = SetProcessWorkingSetSize(pro, -1, -1);
	CloseHandle(pro);

	return result;
}


void TrimProcessByWildcard(char *name)
{
	HANDLE			th32 = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	PROCESSENTRY32	pro32;

	if(INVALID_HANDLE_VALUE == th32)
	{
		printf("Error creating ToolHelp32 snapshot!\n");
		return;
	}

	pro32.dwSize = sizeof(pro32);

	if( !Process32First(th32, &pro32) )
	{
		CloseHandle(th32);
		return;
	}

	do
	{
		if( Wildmatch::szWildMatch(name, pro32.szExeFile) )
		{
			printf("Found match %s for %s, PID %d trimming... ",
				pro32.szExeFile, name, pro32.th32ProcessID);
			bool result = TrimProcess(pro32.th32ProcessID);
			printf("%s\n", result ? "done" : "error");
		}
	} while(Process32Next(th32, &pro32) );

	CloseHandle(th32);
	return;
}


int main(int argc, char *argv[])
{
	if(argc < 2)
	{
		printf("Usage: trimws modname\n");
		return 0;
	}

	Wildmatch::initCaseTable();

	TrimProcessByWildcard(argv[1]);
}
