#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "Wildmatch.h"

#define lengthof(x) (sizeof(x)/sizeof(x[0]))

namespace Wildmatch
{

static char mapCaseTable[256];

void initCaseTable()
{
	for(unsigned i=0; i<lengthof(mapCaseTable); i++)
	{
		mapCaseTable[i] = i;
	}
	CharUpperBuff(mapCaseTable, lengthof(mapCaseTable));
}



// by Alessandro Cantatore
bool szWildMatch(const char *pat, const char *str)
{
	const char *s, *p;
	bool star = false;

	loopStart:
	for (s = str, p = pat; *s; ++s, ++p)
	{
		switch (*p)
		{
		case '?':
			if (*s == '.') goto starCheck;
			break;

		case '*':
			star = TRUE;
			str = s, pat = p;
			do { ++pat; } while (*pat == '*');
			if (!*pat) return TRUE;
			goto loopStart;

		default:
			if (mapCaseTable[*s] != mapCaseTable[*p])
			goto starCheck;
			break;
		} // endswitch
	} // endfor

	while (*p == '*') ++p;
	return (!*p);

starCheck:
	if (!star) return FALSE;
	str++;
	goto loopStart;
}



__declspec(noinline) bool szWildMatch(const std::string& pat, const std::string& str)
{
	return szWildMatch(pat.c_str(), str.c_str());
}

} // Wildmatch namespace
